/* namelist.c */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#include <stdio.h>
#include "util.h"
#include "namelist.h"
#include <isode/quipu/util.h>

void
addToList(lp, str)
struct namelist ** lp;
char *str;
{
  for (;*lp != NULLLIST; lp = &(*lp)->next) {};

  *lp 		= list_alloc();
  (*lp)->name 	= copy_string(str);
  (*lp)->entryDN = NULLDN ;
  (*lp)->ats 	= NULLATTR;
  (*lp)->next 	= NULLLIST;
}

void
freeListpp(listpp)
struct namelist ** listpp;
{
struct namelist * prevAttrListp, * currAttrListp;

        currAttrListp = *listpp;

	while( currAttrListp != NULLLIST )
	{
	    if( currAttrListp -> name != NULLCP )
		free( currAttrListp -> name );

	    if( currAttrListp -> entryDN != NULLDN )
	    	dn_free( currAttrListp -> entryDN ) ;

            as_free( currAttrListp -> ats );

	    prevAttrListp = currAttrListp ;
	    
	    currAttrListp = currAttrListp -> next;

	    free((char *) prevAttrListp );
	}

	*listpp = NULLLIST;
}

